package eu.etaxonomy.taxeditor.navigation.navigator.dnd;

import java.util.ArrayList;
import java.util.List;

import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.swt.dnd.DragSourceEvent;
import org.eclipse.swt.dnd.Transfer;
import org.eclipse.ui.navigator.CommonDragAdapterAssistant;

import eu.etaxonomy.cdm.model.taxon.TaxonNode;
import eu.etaxonomy.taxeditor.dnd.transfer.TaxonNodeTransfer;

public class TaxonNavigatorDragAdapterAssistant extends
		CommonDragAdapterAssistant {

	@Override
	public Transfer[] getSupportedTransferTypes() {
		return new Transfer[] { TaxonNodeTransfer.getInstance() };
	}

	@Override
	public boolean setDragData(DragSourceEvent event,
			IStructuredSelection selection) {
		boolean setDataSuccess = false;
		List<TaxonNode> taxonNodes = new ArrayList<TaxonNode>();
		for (Object object : selection.toList()){
			if(object instanceof TaxonNode){
				taxonNodes.add(((TaxonNode) object));
				setDataSuccess = true;
			}
			
		}
		if (TaxonNodeTransfer.getInstance().isSupportedType(
				event.dataType)) {
			event.data = taxonNodes.toArray(new TaxonNode[taxonNodes.size()]);
		}
		return setDataSuccess;
	}

}
